<template>
    <div :ref="sliderId" v-bind:class="config.styleClass"></div>
</template>

<script>
    import noUiSlider from 'nouislider'

    export default {
        name: "NoUiSlider",
        props: {
            sliderId: {
                type: String,
                default: function () {
                    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                        let r = Math.random() * 16 | 0,
                            v = c === 'x' ? r : (r & 0x3 | 0x8)
                        return v.toString(16)
                    })
                }
            },
            config: Object,
            values: {
                type: Array
            },
        },
        data() {
            return {
                slider: null
            }
        },
        methods: {
            updateValue: function (values, index) {
                this.$set(this.values, index, values[index])
                this.$emit('input', values)
            },
        },
        watch: {
            values: function(val) {
                this.slider.noUiSlider.set(val)
            }
        },
        mounted: function () {
            this.slider = this.$refs[this.sliderId]
            this.config.start = this.values

            noUiSlider.create(this.slider, this.config)

            this.slider.noUiSlider.on('change', this.updateValue)

            this.slider.addEventListener('keydown', (e) => {

                let value = parseInt(this.slider.noUiSlider.get()) || 0

                let multiplicator = 1

                if ( e.which === 37 ) {
                    this.$set(this.values, 0, (value - (this.config.step * multiplicator ) ).toString() )
                    this.$emit('input', this.slider.noUiSlider.get())
                }

                if ( e.which === 39 ) {
                    this.$set(this.values, 0, (value + (this.config.step * multiplicator ) ).toString() )
                    this.$emit('input', this.slider.noUiSlider.get())
                }
            });


        }
    }
</script>

<style scoped>
    @import './../../node_modules/nouislider/distribute/nouislider.min.css';
</style>
